
// signaux manuels (sans BAL) les avertissements et les ralentissement sont geres automatiquement
// ces signaux peuvent etres mecaniques ou lumineux
// pour les signaux mecaniques a plusieurs cibles (2 ou 3) utiliser la classe idoine, 
//    ces signaux ont plusieurs moteurs, pour la manoeuvre utiliser 2 ou 3 numeros consecutifs (no no+1 (no+2))
//    la methode cibles() retourne les cibles a presenter (pour les signaux mecaniques)

/////////////////////////////////////////////////////////////////////////////

class CarreViolet:public Signal {
public:
  CarreViolet(int n):Signal(Cv,n) {} // constructeur mini
  CarreViolet(char* nm,int t,int n):Signal(nm,t+CARRE+VIOLET,Cv,n) {} // constructeur maxi
  
  virtual void ouvrir(); // ouverture manuelle
  virtual void fermer(); // fermeture manuelle
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void CarreViolet::ouvrir() { if (ouvert()) return; feux=M;  manoeuvrer(); }
void CarreViolet::fermer() { if (ferme())  return; feux=Cv; manoeuvrer(); }

/////////////////////////////////////////////////////////////////////////////

class Disque:public Signal { 
public:
  Disque(int n):Signal(D,n) {} // constructeur mini
  Disque(char* nm,int t,int n):Signal(nm,t+DISQUE,D,n) {} // constructeur maxi
 
  virtual void ouvrir(); // ouverture manuelle
  virtual void fermer(); // fermeture manuelle
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void Disque::ouvrir() { if (ouvert()) return; feux=Vl; manoeuvrer(); }
void Disque::fermer() { if (ferme())  return; feux=S;  manoeuvrer(); }

/////////////////////////////////////////////////////////////////////////////

class Semaphore:public Signal { // le precedent est un avertissement 
protected:
  Semaphore(int n):Signal(S,n) {} // constructeur mini
  Semaphore(char* nm,int t,int n):Signal( nm,t+SEMAPHORE,S,n) {} // constructeur maxi
public:  
  virtual void ouvrir(); // ouverture manuelle
  virtual void fermer(); // fermeture manuelle
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void Semaphore::ouvrir() { if (ouvert()) return; feux=Vl; manoeuvreEtMajFeux(); }
void Semaphore::fermer() { if (ferme())  return; feux=S;  manoeuvreEtMajFeux(); }

/////////////////////////////////////////////////////////////////////////////

class Avertissement:public Signal { // le suivant est forcement un carre ou un semaphore
protected:
  Avertissement(int n):Signal(A,n) {} // constructeur mini   
  Avertissement(char* nm,int t,int n):Signal(nm,t+AVERTISSEMENT,A,n) {} // constructeur maxi   
public:  
  virtual void aubiner(); // appelle par les methodes actions de zone   OPTION

  virtual void majFeux(); // appele par le signal suivant           

  virtual int cibles() { return feux!=A?RIEN:CIBLE; } // les cibles a presenter   OPTION
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void Avertissement::aubiner() { 
  if (feux==A) return; feux=A; manoeuvrer(); 
} 

void Avertissement::majFeux() { Signal* s; typeFeux f;            
  s=suivant(); if (s==NULL) { erreur(301); return; }
  if (s->ferme()) f=A; else f=Vl; 
  if (f!=feux) { feux=f; manoeuvrer(); } 
 } 

/////////////////////////////////////////////////////////////////////////////

class AvertissementRalentissement:public Avertissement { // le suivant est forcement un carre
protected:
  AvertissementRalentissement(int n):Avertissement(n) {} // constructeur mini
  AvertissementRalentissement(char* nm,int t,int n):Avertissement(nm,t+AVERTISSEMENT+RALENTISSEMENT,n) {} // constructeur maxi
public:  
  virtual void majFeux(); // appele par le signal suivant           
 
  virtual int cibles(); // les cibles a presenter   OPTION
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void AvertissementRalentissement::majFeux() { Signal* s; typeFeux f;            
  s=suivant(); if (s==NULL) { erreur(301); return; }
  if (s->ferme()) feux=A;          else
  if (s->ralentissement60()) f=Rc; else
  if (s->ralentissement30()) f=R; 
  else                       f=Vl;  
  if (f!=feux) { feux=f; manoeuvrer(); } 
} 

int AvertissementRalentissement::cibles() { 
  switch(feux) {
    case A:  return CIBLE+CIBLE_BIS; // avertissement et ralentissement
    case R:  return CIBLE_BIS; // ralentissement
    default: return RIEN;
  }
}

/////////////////////////////////////////////////////////////////////////////

class Carre:public Signal {
protected:
  Carre(int n):Signal(C,n) {} // constructeur mini
  Carre(char* nm,int t,int n):Signal(nm,t+CARRE,C,n) {} // constructeur maxi
public:  
  virtual void ouvrir(); // ouverture manuelle 
  virtual void fermer(); // fermeture manuelle
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void Carre::ouvrir() { if (ouvert()) return; feux=Vl; manoeuvreEtMajFeux(); } 
void Carre::fermer() { if (ferme())  return; feux=C;  manoeuvreEtMajFeux(); } 

/////////////////////////////////////////////////////////////////////////////

class CarreRappelRalentissement:public Carre {
protected:
  CarreRappelRalentissement(int n):Carre(n) {} // constructeur
  CarreRappelRalentissement(char* nm,int t,int n):Carre(nm,t+CARRE+RAPPEL_RALENTISSEMENT,n) {} // constructeur
public:
  virtual void ouvrir(); // ouverture manuelle 

  virtual int cibles(); // les cibles a presenter   OPTION
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void CarreRappelRalentissement::ouvrir() { 
  if (ouvert()) return; 
  if (ralentissement60()) feux=RRc; else
  if (ralentissement30()) feux=RR; 
  else                    feux=Vl;
  manoeuvreEtMajFeux(); 
} 

int CarreRappelRalentissement::cibles() { 
  switch(feux) {
    case C:  return CIBLE+CIBLE_BIS; // carre et ralentissement
    case RR: return CIBLE_BIS; // rappel ralentissement
    default: return RIEN;
  }
}
  
/////////////////////////////////////////////////////////////////////////////

class CarreAvertissement:public Carre { // avertissement pour le carre suivant
protected:
  CarreAvertissement(int n):Carre(n) {} // constructeur mini
  CarreAvertissement(char* nm,int t,int n):Carre(nm,t+CARRE+AVERTISSEMENT,n) {} // constructeur maxi
public:
  virtual void ouvrir(); // ouverture manuelle
    
  virtual typeFeux calculFeux();
  virtual void majFeux();

  virtual int cibles(); // OPTION
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

void CarreAvertissement::ouvrir() { if (ouvert()) return; feux=calculFeux(); manoeuvreEtMajFeux(); }

typeFeux CarreAvertissement::calculFeux() { Signal* s; 
    s=suivant(); if (s==NULL) { erreur(301); return E; }
if (s->ferme()) feux=A; else feux=Vl;
}

void CarreAvertissement::majFeux() { Signal* s; typeFeux f; // appele par le carre suivant    
  if (ferme()) return;       
  s=suivant(); if (s==NULL) { erreur(301); return; }
  if (s->ferme()) f=A; else f=Vl; 
  if (f!=feux) { feux=f; manoeuvrer(); } 
} 

int CarreAvertissement::cibles() { 
  switch(feux) {
    case C:  return CIBLE+CIBLE_BIS; // carre et avertissement
    case A:  return CIBLE_BIS; // avertissement
    default: return RIEN;
  }
}

/////////////////////////////////////////////////////////////////////////////

class CarreAvertissementRappelRalentissement:public CarreAvertissement { // ralentissement pour le carre suivant
protected:
  CarreAvertissementRappelRalentissement(int n):CarreAvertissement(n) {} // constructeur mini
  CarreAvertissementRappelRalentissement(char* nm,int t,int n):CarreAvertissement(nm,t+CARRE+RALENTISSEMENT+RAPPEL_RALENTISSEMENT,n) {} // constructeur maxi
public:  
  virtual typeFeux calculFeux(); // feux a l'ouverture

  virtual int cibles(); // OPTION
};

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  

typeFeux CarreAvertissementRappelRalentissement::calculFeux() { Signal* s; 
  s=suivant(); if (s==NULL) { erreur(301); return E; }
  if (s->ralentissement60()) if (s->ferme()) return A+RRc; else return RRc; else
  if (s->ralentissement30()) if (s->ferme()) return A+RR;  else return RR; 
  else                       if (s->ferme()) return A;     else return Vl;
}

int CarreAvertissementRappelRalentissement::cibles() { 
  switch(feux) { // pas de RR60 sur les signaux mécaniques
    case C:    return CIBLE+CIBLE_BIS+CIBLE_TER; // carre, avertissement et rappel ralentissement
    case A:    return CIBLE_BIS; // avertissement
    case RR:   return CIBLE_TER; // rappel ralentissement
    case A+RR: return CIBLE_BIS+CIBLE_TER; // avertissement et rappel ralentissement
    default: return RIEN;
  }
}
  
/////////////////////////////////////////////////////////////////////////////

